<?php
/*
Plugin Name: EasyToolsWP V2
Plugin URI: https://easytoolswp.com/easytoolswp-v2.zip
Description: Hovedplugin til at organisere andre EasyTools plugins.
Version: 2.0.8
Author: EasyToolsWP.com
Author URI: https://www.easytoolswp.com
*/

// Hook til at oprette admin menu
add_action('admin_menu', 'easytoolswp_admin_menu');

function easytoolswp_admin_menu() {
    if (!current_user_can('administrator')) {
        return;
    }
    add_menu_page('EasyToolsWP', 'EasyToolsWP', 'manage_options', 'easytoolswp', 'easytoolswp_updates', 'dashicons-plus-alt');
    add_submenu_page('easytoolswp', 'Add-ons', 'Add-ons', 'manage_options', 'easytoolswp_plugins', 'easytoolswp_pluginlist_page');
    add_submenu_page('easytoolswp', 'EasyInstall', 'EasyInstall', 'manage_options', 'easytoolswp_easyinstall', 'easytoolswp_easyinstall_page');
    add_submenu_page('', '1-Click', '1-Click', 'manage_options', 'easytoolswp_recommended', 'easytoolswp_recommended_plugins_page');
    add_submenu_page('', 'Theme Installer', 'Theme Installer', 'manage_options', 'easytoolswp_theme-installer', 'easytoolswp_theme_installer_page');
	add_submenu_page('', 'Settings', 'Settings', 'manage_options', 'easytoolswp_pro-settings', 'easytoolswp_pro_settings_page');

}

function easytoolswp_pro_settings_page() {
    // Funktionen easytoolswp_pro_settings_page() skal defineres for at vise indholdet på undersiden.
    echo '<style>';
	echo '.wrap{background-color:#fff; padding:15px; width:35%; display:block; vertical-align:top;}';
    echo 'h2 {padding: 10px; color: #fff; background: rgb(103, 209, 99); background: linear-gradient(90deg, rgba(103, 209, 99, 1) 0%, rgba(91, 186, 146, 1) 45%, rgba(85, 169, 180, 1) 100%); }';
    echo '</style>';
}

function easytoolswp_updates() {
    // Get the plugin data
    $plugin_data = get_plugin_data(__FILE__);
    $version = $plugin_data['Version']; // Get the current version of the plugin
    $plugin_uri = $plugin_data['PluginURI']; // Get the Plugin URI

    ?>
    <div class="wrap">
        <div class="button button-primary"><a style="color:#fff;" href="?page=easytoolswp_easyinstall">INSTALL</a></div>
		<div class="button button-primary"><a style="color:#fff;" href="?page=easytoolswp_pro-settings">SETTINGS</a></div>
        <div class="button"><a href="?page=easytoolswp_theme-installer">THEMES</a></div>
		<span class="etwp-pro"><div class="button"><a href="?page=easytoolswp_recommended">RECOMMENDED</a></div></span>
		<span class="etwp-pro"><div class="button"><a href="https://www.easytoolswp.com/get-help/" target="_blank">GET HELP</a></div></span>
		<span class="etwp-pro"><div class="button"><a href="https://www.easytoolswp.com/wp-admin/site-health.php">SITE HEALTH</a></div></span>
		

        <h1>EasyToolsWP V<?php echo esc_html($version); ?> <span class="etwp-pro">PRO</span></h1> <!-- Display the correct version number -->
        <p>
            EasyToolsWP is a lightweight plugin with a ton of 1-click features<br/>
            Get easily started with Wordpress in few minutes with our 1-click <a href="?page=easytoolswp_theme-installer">themes</a> and <a href="?page=easytoolswp_recommended">recommended plugins</a>.<br/>
            EasyToolsWP Add-ons have made it easy to build your own WordPress platform with the desired functions.
        </p><p class="etwp-free etwp-notice">Buy EasyToolsWP <strong>PRO</strong> to unlock PRO features - <a href="https://www.easytoolswp.com/download/pro-features/" target="_blank">Buy now</a></p>

<?php
// RSS feed URLs
$rss_feed_addons = 'https://www.easytoolswp.com/add-ons/plugins/feed/'; // Feed for add-ons
$rss_feed_updates = 'https://www.easytoolswp.com/feed/'; // Feed for updates

// Function to fetch feed
function fetch_feed_items($feed_url) {
    if (!function_exists('fetch_feed')) {
        include_once(ABSPATH . WPINC . '/feed.php');
    }

    // Fetch feed
    $rss = fetch_feed($feed_url);

    if (is_wp_error($rss)) {
        echo '<p>' . esc_html($rss->get_error_message()) . '</p>';
        return array();
    }

    // Feed items
    $maxitems = $rss->get_item_quantity(10); // Number of items to display
    $rss_items = $rss->get_items(0, $maxitems);

    return $rss_items;
}

// Fetch add-ons feed items
$rss_items_addons = fetch_feed_items($rss_feed_addons);

// Fetch updates feed items
$rss_items_updates = fetch_feed_items($rss_feed_updates);

// Output the feeds in separate sections
?>

<div class="etwp-flex-container">
    <div class="etwp-feed-box">
        <h2>Add-ons</h2>
        <?php if (empty($rss_items_addons)) : ?>
            <p>No items.</p>
        <?php else : ?>
            <ul>
                <?php foreach ($rss_items_addons as $item) : ?>
                    <li class="addonlinks">
                        <a href="<?php echo esc_url($item->get_permalink()); ?>" target="_blank"><?php echo esc_html($item->get_title()); ?></a>
                    </li>
                <?php endforeach; ?>
            </ul>
        <?php endif; ?>
    </div>

    <div class="etwp-feed-box etwp-pro">
        <h2>Updates</h2>
        <?php if (empty($rss_items_updates)) : ?>
            <p>No items.</p>
        <?php else : ?>
            <ul>
                <?php foreach ($rss_items_updates as $item) : ?>
                    <li class="updatelinks">
                        <a href="<?php echo esc_url($item->get_permalink()); ?>" target="_blank"><?php echo esc_html($item->get_title()); ?></a>
                    </li>
                <?php endforeach; ?>
            </ul>
        <?php endif; ?>
    </div>
</div>
    </div>
    <br/>
    <p><a href="https://www.linkedin.com/company/easytoolswp/" target="_blank">Visit us on Linkedin</a></p>
    <p><a href="https://www.facebook.com/groups/778952077642032" target="_blank">Danish Support (facebook group)</a></p>
	<p class="etwp-pro"><a href="https://www.easytoolswp.com/get-help/" target="_blank">GET HELP</a></p>
    <p class="thankstxt">The use of EasyToolsWP (V<?php echo esc_html($version); ?>) and EasyTools Add-ons is at your own risk<br/>EasyToolsWP is made by Royaldigital ApS (Denmark)</p>
<br/>
        <div class="button button-grey"><a id="update-easytoolswp" href="#">Update EasyToolsWP</a></div> <!-- Update button -->

    <style>
	.button-grey {float:right; background-color:#fff!important; border:1px solid #ccc!important; margin:25px!important;}
	.button-grey a {color:#ccc!important;}
    .addonlinks,.updatelinks {background-color:#fff; padding:8px; display:block; margin:8px;}
    .button a {text-decoration:none;}
    .thankstxt {color:#999; font-size:0.7em;}
		
		.etwp-notice{display:inline-block; padding:10px; color:#fff;
		background: rgb(103,209,99);
background: linear-gradient(90deg, rgba(103,209,99,1) 0%, rgba(91,186,146,1) 45%, rgba(85,169,180,1) 100%);
		}.etwp-notice a{color:#fff;}
		
		.etwp-flex-container {
        display: flex;
        gap: 20px;
        justify-content: space-around;
        flex-wrap: wrap;
    }

    .etwp-feed-box {
        flex: 1 1 40%; /* Adjust as per your layout needs */
        padding: 10px;
        border: 1px solid #ccc;
        border-radius: 5px;
    }

    .etwp-feed-box h2 {
        font-size: 1.2em;
        margin-bottom: 10px;
    }

    .etwp-feed-box ul {
        list-style-type: none;
        padding: 0;
    }

    .etwp-feed-box li {
        margin-bottom: 5px;
    }
    </style>
    <script>
    jQuery(document).ready(function($) {
        $('#update-easytoolswp').on('click', function(e) {
            e.preventDefault();
            $.ajax({
                url: ajaxurl,
                type: 'POST',
                data: {
                    action: 'easytoolswp_update_plugin'
                },
                success: function(response) {
                    if(response.success) {
                        alert('Plugin updated successfully.');
                    } else {
                        alert('Error: ' + response.data);
                    }
                },
                error: function() {
                    alert('Error updating plugin.');
                }
            });
        });
    });
    </script>
    <?php
}

// Add the AJAX action for updating the plugin
add_action('wp_ajax_easytoolswp_update_plugin', 'easytoolswp_update_plugin');
function easytoolswp_update_plugin() {
    // Get the plugin data
    $plugin_data = get_plugin_data(__FILE__);
    $plugin_slug = plugin_basename(__FILE__); // Get the plugin slug
    $plugin_dir = dirname($plugin_slug); // Get the plugin directory name
    $plugin_uri = $plugin_data['PluginURI']; // Get the Plugin URI

    // Include necessary files for updating plugins
    include_once(ABSPATH . 'wp-admin/includes/class-wp-upgrader.php');
    include_once(ABSPATH . 'wp-admin/includes/file.php');
    include_once(ABSPATH . 'wp-admin/includes/plugin.php');
    include_once(ABSPATH . 'wp-admin/includes/plugin-install.php');

    // Assume Plugin URI is the direct download link
    $download_link = $plugin_uri;

    // Check for filesystem access
    $access_type = get_filesystem_method();
    if ($access_type === 'direct') {
        $credentials = request_filesystem_credentials(site_url() . '/wp-admin/', '', false, false, null);
        if (!WP_Filesystem($credentials)) {
            wp_send_json_error('Could not access filesystem.');
            return;
        }
    }

    // Create a new instance of Plugin_Upgrader
    $skin = new WP_Ajax_Upgrader_Skin();
    $upgrader = new Plugin_Upgrader($skin);

    // Download the zip file to a temporary location
    $downloaded_zip = download_url($download_link);
    if (is_wp_error($downloaded_zip)) {
        wp_send_json_error($downloaded_zip->get_error_message());
        return;
    }

    // Unzip the downloaded file
    $result = unzip_file($downloaded_zip, WP_PLUGIN_DIR . '/' . $plugin_dir);
    if (is_wp_error($result)) {
        wp_send_json_error($result->get_error_message());
        return;
    }

    // Clean up: delete the downloaded zip file
    unlink($downloaded_zip);

    // If we've reached this point, the plugin was successfully updated
    wp_send_json_success();
}
function easytoolswp_pluginlist_page() {
    ob_start();
    ?>
    <div class="wrap">
        <div class="button button-primary"><a style="color:#fff;" href="?page=easytoolswp_easyinstall">INSTALL</a></div>
        <h1>EasyToolsWP Add-ons</h1>
        <?php
        // Check for actions
        if (isset($_GET['action']) && isset($_GET['plugin'])) {
            $action = sanitize_text_field($_GET['action']);
            $plugin = sanitize_text_field($_GET['plugin']);
            if ($action === 'activate') {
                activate_plugin($plugin);
                echo '<div class="updated"><p>Plugin activated successfully!</p></div>';
            } elseif ($action === 'deactivate') {
                deactivate_plugins($plugin);
                echo '<div class="updated"><p>Plugin deactivated successfully!</p></div>';
            } elseif ($action === 'update') {
                $plugin_data = get_plugin_data(WP_PLUGIN_DIR . '/' . $plugin);
                $plugin_uri = $plugin_data['PluginURI'];
                if (!empty($plugin_uri)) {
                    easytoolswp_replace_plugin($plugin_uri, $plugin);
                }
            }
        }

        // Fetch plugins
        $all_plugins = get_plugins();
        $easytools_plugins = array_filter($all_plugins, function($plugin) {
            return strpos($plugin['Name'], 'EasyTools') !== false;
        });

        // Get the plugin file path for EasyToolsWP
        $easytoolswp_plugin_file = 'easytoolswp-v2/easytoolswp-v2.php';

        echo '<table class="wp-list-table widefat fixed striped plugins">';
        echo '<thead><tr><th>Name</th><th>Description</th><th>Version</th><th>Actions</th></thead><tbody>';
        foreach ($easytools_plugins as $plugin_file => $plugin_data) {
            // Skip EasyToolsWP plugin itself
            if ($plugin_file === $easytoolswp_plugin_file) {
                continue;
            }

            $is_active = is_plugin_active($plugin_file);
            echo '<tr>';
            echo '<td class="plugin-title">' . esc_html($plugin_data['Name']) . '</td>';
            echo '<td>' . esc_html($plugin_data['Description']) . '</td>';
            echo '<td>' . esc_html($plugin_data['Version']) . '</td>';
            echo '<td>';
            if ($is_active) {
                echo '<a href="' . esc_url(add_query_arg(['action' => 'deactivate', 'plugin' => $plugin_file])) . '" class="button">Deactivate</a> ';
            } else {
                echo '<a href="' . esc_url(add_query_arg(['action' => 'activate', 'plugin' => $plugin_file])) . '" class="button button-primary">Activate</a> ';
                echo '<button class="button button-secondary" onclick="easytoolswp_delete_plugin(\'' . esc_js($plugin_file) . '\')">Delete</button> ';
                // Check if PluginURI exists for update button
                $plugin_uri = $plugin_data['PluginURI'];
                if (!empty($plugin_uri)) {
                    echo '<a href="' . esc_url(add_query_arg(['action' => 'update', 'plugin' => $plugin_file])) . '" class="button button-primary" onclick="return confirm(\'Are you sure you want to update this plugin? This action will overwrite the current version.\')">Update</a>';
                }
            }
            echo '</td>';
            echo '</tr>';
        }
        echo '</tbody></table><br/><div class="button"><a href="https://www.easytoolswp.com/plugins/" target="blank">SEE ALL ADD-ONS</a></div>';
        ?>
    </div>
    <script>
        function easytoolswp_delete_plugin(plugin) {
            if (confirm('Are you sure you want to delete this plugin? This action cannot be undone.')) {
                var data = new FormData();
                data.append('action', 'easytoolswp_delete_plugin');
                data.append('plugin', plugin);
                data.append('security', '<?php echo wp_create_nonce('easytoolswp_delete_plugin_nonce'); ?>');
                fetch(ajaxurl, {
                    method: 'POST',
                    credentials: 'same-origin',
                    body: data
                })
                .then(response => response.json())
                .then(result => {
                    if (result.success) {
                        alert('Plugin deleted successfully!');
                        location.reload();
                    } else {
                        alert('Error deleting plugin: ' + result.data);
                    }
                });
            }
        }
    </script>
    <?php
    echo ob_get_clean();
}

// Ajax handler for deleting a plugin
add_action('wp_ajax_easytoolswp_delete_plugin', 'easytoolswp_delete_plugin_ajax');

function easytoolswp_delete_plugin_ajax() {
    check_ajax_referer('easytoolswp_delete_plugin_nonce', 'security');

    if (!current_user_can('delete_plugins')) {
        wp_send_json_error('You do not have permission to delete plugins.');
    }

    $plugin = sanitize_text_field($_POST['plugin']);

    if (is_plugin_active($plugin)) {
        wp_send_json_error('Cannot delete an active plugin.');
    }

    $result = delete_plugins([$plugin]);

    if (is_wp_error($result)) {
        wp_send_json_error($result->get_error_message());
    }

    wp_send_json_success();
}

// Filter for at skjule EasyTools plugins fra den officielle plugin-liste
add_filter('all_plugins', 'easytoolswp_filter_plugins');

function easytoolswp_filter_plugins($plugins) {
    foreach ($plugins as $plugin_file => $plugin_data) {
        if (strpos($plugin_data['Name'], 'EasyTools') !== false) {
            unset($plugins[$plugin_file]);
        }
    }
    return $plugins;
}

// Function to replace (update) the plugin
function easytoolswp_replace_plugin($url, $plugin) {
    include_once ABSPATH . 'wp-admin/includes/file.php';
    include_once ABSPATH . 'wp-admin/includes/misc.php';
    include_once ABSPATH . 'wp-admin/includes/class-wp-upgrader.php';

    $upgrader = new Plugin_Upgrader();

    // Download the new plugin version
    $downloaded_file = download_url($url);

    if (is_wp_error($downloaded_file)) {
        echo '<div class="error"><p>Download error: ' . esc_html($downloaded_file->get_error_message()) . '</p></div>';
        return;
    }

    // Deactivate the existing plugin before updating
    deactivate_plugins($plugin);

    // Remove the existing plugin files
    delete_plugins([$plugin]);

    // Install the new plugin version
    $result = $upgrader->install($downloaded_file);

    if (is_wp_error($result)) {
        echo '<div class="error"><p>Installation error: ' . esc_html($result->get_error_message()) . '</p></div>';
    } else {
        echo '<div class="updated"><p>Plugin updated successfully!</p></div>';
    }

    @unlink($downloaded_file);
}

function easytoolswp_easyinstall_page() {
    ?> 
		<div class="wrap">
		<div class="button"><a href="?page=easytoolswp_theme-installer">THEMES</a></div>
       	 <div class="button"><a href="?page=easytoolswp_recommended">RECOMMENDED</a></div>
		</div>  
    <div class="wrap easyinstall">
        <h1>EasyInstall</h1>
        <form method="post" enctype="multipart/form-data">
            <label for="easytoolswp_install_url">Plugin URL (zip-fil):</label><br/>
            <input type="text" id="easytoolswp_install_url" name="easytoolswp_install_url" style="width: 50%;">
            <input type="submit" name="easytoolswp_install_submit" value="Install" id="easytoolswp_install_submit" class="button button-primary">
        </form>
				<br/><a href="https://www.easytoolswp.com/account/downloads/" target="_blank">Find your add-ons - Click here</a>
    </div>
    <style>
        .wrap.easyinstall {
            background-color: #fff;
            padding: 25px;
            margin-top: 25px;
            border: 3px solid #ccc;
            text-align: center;
            vertical-align: center;
            width: 50%;
        }
        .wrap.easyinstall #easytoolswp_install_url {
            background-color: #efefef;
            padding: 5px;
            border: 3px solid #ccc;
        }
        .wrap.easyinstall #easytoolswp_install_submit {
            background-color: #669933;
            padding: 5px;
            border: 3px solid #669933;
            text-align: center;
        }
    </style>
    <?php
    if (isset($_POST['easytoolswp_install_submit'])) {
        $url = sanitize_text_field($_POST['easytoolswp_install_url']);
        easytoolswp_install_plugin($url);
    }
}

function easytoolswp_install_plugin($url) {
    include_once ABSPATH . 'wp-admin/includes/file.php';
    include_once ABSPATH . 'wp-admin/includes/misc.php';
    include_once ABSPATH . 'wp-admin/includes/class-wp-upgrader.php';

    $upgrader = new Plugin_Upgrader();
    $downloaded_file = download_url($url);

    if (is_wp_error($downloaded_file)) {
        echo '<div class="error"><p>Download error: ' . esc_html($downloaded_file->get_error_message()) . '</p></div>';
        return;
    }

    $result = $upgrader->install($downloaded_file);

    if (is_wp_error($result)) {
        echo '<div class="error"><p>Installation error: ' . esc_html($result->get_error_message()) . '</p></div>';
    } else {
        echo '<div class="updated"><p>Plugin installed successfully!</p></div>';
    }

    @unlink($downloaded_file);
}

// Recommended Plugins Page
function easytoolswp_recommended_plugins_page() {
    ?>
    <div class="wrap">
        <h1>Recommended Plugins</h1>
		<p>
			See recommended list for WooCommerce, Elementor and CF7 - <a href="https://www.easytoolswp.com/one-click/" target="_blank">Click her</a>
		</p>
        <?php
        // List of recommended plugins
        $recommended_plugins = [
			'elementor/elementor.php',
			'header-footer-elementor/header-footer-elementor.php',
			'duplicate-post/duplicate-post.php',
			'wp-404-auto-redirect-to-similar-post/wp-404-auto-redirect-similar-post.php',
			'page-list/page-list.php',
			'megamenu/megamenu.php',
			'wordpress-seo/wp-seo.php',
			'performance-lab/load.php',
            'sitekit/sitekit.php',
			'contact-form-7/wp-contact-form-7.php',
            'woocommerce/woocommerce.php',
			'gtranslate/gtranslate.php',
			'loco-translate/loco.php',
			'wps-hide-login/wps-hide-login.php',
			'klaviyo/klaviyo.php',
            // Add more plugins here as needed
        ];

        // Fetch plugin information
        include_once ABSPATH . 'wp-admin/includes/plugin-install.php';
        include_once ABSPATH . 'wp-admin/includes/plugin.php';

        echo '<table class="wp-list-table widefat fixed striped plugins">';
        echo '<thead><tr><th>Name</th><th>Description</th><th>Version</th><th>Actions</th></tr></thead><tbody>';

        foreach ($recommended_plugins as $plugin_slug) {
            $api = plugins_api('plugin_information', array(
                'slug' => dirname($plugin_slug),
                'fields' => array(
                    'short_description' => true,
                    'sections' => false,
                    'homepage' => true,
                    'version' => true,
                    'author' => true,
                    'author_profile' => true,
                    'requires' => true,
                    'tested' => true,
                    'compatibility' => true,
                    'rating' => true,
                    'num_ratings' => true,
                    'downloaded' => true,
                    'last_updated' => true,
                    'added' => true,
                    'tags' => true,
                    'donate_link' => true,
                ),
            ));

            if (is_wp_error($api)) {
                continue;
            }

            $is_installed = file_exists(WP_PLUGIN_DIR . '/' . $plugin_slug);
            $is_active = is_plugin_active($plugin_slug);

            echo '<tr>';
            echo '<td class="plugin-title"><strong>' . esc_html($api->name) . '</strong></td>';
            echo '<td>' . esc_html($api->short_description) . '</td>';
            echo '<td>' . esc_html($api->version) . '</td>';
            echo '<td>';
            if ($is_installed) {
                if ($is_active) {
                    echo '<a href="' . esc_url(add_query_arg(['action' => 'deactivate', 'plugin' => $plugin_slug])) . '" class="button">Deactivate</a> ';
                } else {
                    echo '<a href="' . esc_url(add_query_arg(['action' => 'activate', 'plugin' => $plugin_slug])) . '" class="button button-primary">Activate</a> ';
                }
                echo '<button class="button button-secondary" onclick="easytoolswp_delete_plugin(\'' . esc_js($plugin_slug) . '\')">Delete</button>';
            } else {
                echo '<a href="' . wp_nonce_url(self_admin_url('update.php?action=install-plugin&plugin=' . dirname($plugin_slug)), 'install-plugin_' . dirname($plugin_slug)) . '" class="button button-primary">Install Now</a>';
            }
            echo '</td>';
            echo '</tr>';
        }
        echo '</tbody></table>';
        ?>
    </div>
    <script>
        function easytoolswp_delete_plugin(plugin) {
            if (confirm('Are you sure you want to delete this plugin? This action cannot be undone.')) {
                var data = new FormData();
                data.append('action', 'easytoolswp_delete_plugin');
                data.append('plugin', plugin);
                data.append('security', '<?php echo wp_create_nonce('easytoolswp_delete_plugin_nonce'); ?>');
                fetch(ajaxurl, {
                    method: 'POST',
                    credentials: 'same-origin',
                    body: data
                })
                .then(response => response.json())
                .then(result => {
                    if (result.success) {
                        alert('Plugin deleted successfully!');
                        location.reload();
                    } else {
                        alert('Error deleting plugin: ' + result.data);
                    }
                });
            }
        }
    </script>
    <?php
}

function easytoolswp_theme_installer_page() {
    ?>
    <div class="wrap">
        <h1>Installer Temaer</h1>
        <form method="post" action="">
			<div style="display:inline-block; padding:25px; margin:10px; background-color:#fff;">
				<img src="https://ts.w.org/wp-content/themes/hello-elementor/screenshot.png?ver=3.1.0?ver=3.1.0" width="380"><br/>
				<input type="submit" name="install_hello_elementor" value="Install Hello Elementor" class="button" />
			</div>
			<div style="display:inline-block; padding:25px; margin:10px; background-color:#fff;">
				<img src="http://www.easytoolswp.com/wp-content/uploads/2024/07/easytools-screenshot.png" width="380"><br/>
				<input type="submit" name="install_easytoolswp_theme" value="Install EasyToolsWP Theme" class="button" />
			</div>
        </form>
    </div>
    <?php
    cti_handle_theme_installation();
}

function cti_handle_theme_installation() {
    if (isset($_POST['install_hello_elementor'])) {
        cti_install_hello_elementor();
    }

    if (isset($_POST['install_easytoolswp_theme'])) {
        cti_install_easytoolswp_theme();
    }
}

function cti_install_hello_elementor() {
    include_once(ABSPATH . 'wp-admin/includes/class-wp-upgrader.php');
    $theme_slug = 'hello-elementor';
    $theme_source = 'https://downloads.wordpress.org/theme/hello-elementor.latest-stable.zip';

    $upgrader = new Theme_Upgrader();
    $installed = $upgrader->install($theme_source);

    if ($installed) {
        switch_theme($theme_slug);
        echo '<div class="notice notice-success is-dismissible"><p>Hello Elementor temaet er installeret og aktiveret.</p></div>';
    } else {
        echo '<div class="notice notice-error is-dismissible"><p>Der opstod en fejl under installation af Hello Elementor temaet.</p></div>';
    }
}

function cti_install_easytoolswp_theme() {
    include_once(ABSPATH . 'wp-admin/includes/class-wp-upgrader.php');
    $theme_source = 'https://www.easytoolswp.com/theme/easytoolswp-theme.zip';

    $upgrader = new Theme_Upgrader();
    $installed = $upgrader->install($theme_source);

    if ($installed) {
        // Assuming the theme slug is easytoolswp-theme
        switch_theme('easytoolswp-theme');
        echo '<div class="notice notice-success is-dismissible"><p>EasyToolsWP temaet er installeret og aktiveret.</p></div>';
    } else {
        echo '<div class="notice notice-error is-dismissible"><p>Der opstod en fejl under installation af EasyToolsWP temaet.</p></div>';
    }
}

// Hook for adding admin menus addnewplugin
add_action('admin_menu', 'easytoolswp_add_addnewplugin_page');

// Function to add menu and page addnewplugin
function easytoolswp_add_addnewplugin_page() {
    add_submenu_page(
        'easytoolswp',           // Parent slug
        'Add new',               // Page title
        'Add new',               // Menu title
        'manage_options',        // Capability
        'easytoolswp-addnewplugin',   // Menu slug
        'easytoolswp_addnewplugin_page_content' // Callback function
    );
}

// Callback function to display content of addnewplugin page
function easytoolswp_addnewplugin_page_content() {
    ?>
        <iframe src="https://www.easytoolswp.com/v2-dashboard/add-new/" style="width: 100%; height: 100vh; border: none; margin-left:-20px; margin-right:-20px;"></iframe>
    <?php
}

// Hook for adding admin menus
add_action('admin_menu', 'easytoolswp_add_upgrade_page');

// Function to add menu and page
function easytoolswp_add_upgrade_page() {
    add_submenu_page(
        'easytoolswp',                      // Parent slug
        'Upgrade',                          // Page title
        'Upgrade to PRO',                   // Menu title
        'manage_options',                   // Capability
        'easytoolswp-upgrade',              // Menu slug
        'easytoolswp_upgrade_page_content'  // Callback function
    );
}

// Callback function to display content of upgrade page
function easytoolswp_upgrade_page_content() {
    ?>
        <iframe src="https://www.easytoolswp.com/v2-dashboard/" style="width: 100%; height: 100vh; border: none; margin-left:-20px; margin-right:-20px;"></iframe>
    <?php
}

// Add inline CSS to style the last submenu link
add_action('admin_head', 'easytoolswp_custom_submenu_css');

function easytoolswp_custom_submenu_css() {
    ?>
    <style>
        #adminmenu #toplevel_page_easytoolswp .wp-submenu li a[href="admin.php?page=easytoolswp-upgrade"] {
            color: #55a9b4; /* Change color as needed */
            font-weight: bold; /* Example of additional style */
        }
    </style>
    <?php
}

// Funktion til at tilføje CSS
function min_plugin_custom_css() {
    // Tilføj CSS kun til admin-sider
    if (is_admin()) {
        echo '<style>.etwp-pro{display:none;}</style>';
    }
}

// Tilføj hook til at tilføje CSS
add_action('admin_enqueue_scripts', 'min_plugin_custom_css');
?>